/* gTask
 * Copyright (C) 2004 Michael Henson                                       
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef GTASK_QUERY_PACKET_H
#define GTASK_QUERY_PACKET_H

#include <gtask/gtask-packet.h>

/** @addtogroup GTaskQueryPacket */

/* @{ */

typedef struct _GTaskQueryPacket        GTaskQueryPacket;
typedef struct _GTaskQueryPacketPrivate GTaskQueryPacketPrivate;
typedef struct _GTaskQueryPacketClass   GTaskQueryPacketClass;


/** returns the GType of GTaskQueryPacket */
#define GTASK_QUERY_PACKET_TYPE            (gtask_query_packet_get_type())

/** casts the passed in object to a GTaskQueryPacket */
#define GTASK_QUERY_PACKET(obj)            (G_TYPE_CHECK_INSTANCE_CAST( (obj), \
                                            GTASK_QUERY_PACKET_TYPE, \
                                            GTaskQueryPacket ))

/** casts the passed in object to a GTaskQueryPacketClass */
#define GTASK_QUERY_PACKET_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST( (klass), \
                                            GTASK_QUERY_PACKET_TYPE, \
                                            GTaskQueryPacketClass ))

/**
 * returns TRUE if the passed in object is a GTaskQueryPacket,
 * FALSE otherwise
 */
#define GTASK_IS_QUERY_PACKET(obj)         (G_TYPE_CHECK_INSTANCE_TYPE( (obj), \
                                            GTASK_QUERY_PACKET_TYPE ))

/**
 * returns TRUE if the passed in object is a GTaskQueryPacketClass,
 * FALSE otherwise
 */
#define GTASK_IS_QUERY_PACKET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE( (klass), \
                                            GTASK_QUERY_PACKET_TYPE ))

#define GTASK_QUERY_PACKET_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS( (obj), \
                                            GTASK_QUERY_PACKET_TYPE, \
                                            GTaskQueryPacketClass ))

struct _GTaskQueryPacket {
    GObject                  parent;
    GTaskQueryPacketPrivate *private;
};

struct _GTaskQueryPacketPrivate {
};

struct _GTaskQueryPacketClass {
    GTaskPacketClass parent;
};

GType gtask_query_packet_get_type( void );

GTaskQueryPacket *
gtask_query_packet_new( void );

/* @} */

#endif
