/* gTask
 * Copyright (C) 2004 Michael Henson                                       
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef GTASK_REMOVE_WATCH_PACKET_H
#define GTASK_REMOVE_WATCH_PACKET_H

#include <gtask/gtask-packet.h>
#include <gtask/gtask-connection.h>

/** @addtogroup GTaskRemoveWatchPacket */

/* @{ */

typedef struct _GTaskRemoveWatchPacket        GTaskRemoveWatchPacket;
typedef struct _GTaskRemoveWatchPacketPrivate GTaskRemoveWatchPacketPrivate;
typedef struct _GTaskRemoveWatchPacketClass   GTaskRemoveWatchPacketClass;


/** returns the GType of GTaskRemoveWatchPacket */
#define GTASK_REMOVE_WATCH_PACKET_TYPE    (gtask_remove_watch_packet_get_type())

/** casts the passed in object to a GTaskRemoveWatchPacket */
#define GTASK_REMOVE_WATCH_PACKET(obj)     (G_TYPE_CHECK_INSTANCE_CAST( (obj), \
                                            GTASK_REMOVE_WATCH_PACKET_TYPE, \
                                            GTaskRemoveWatchPacket ))

/** casts the passed in object to a GTaskRemoveWatchPacketClass */
#define GTASK_REMOVE_WATCH_PACKET_CLASS(klass) \
                                           (G_TYPE_CHECK_CLASS_CAST( (klass), \
                                            GTASK_REMOVE_WATCH_PACKET_TYPE, \
                                            GTaskRemoveWatchPacketClass ))

/**
 * returns TRUE if the passed in object is a GTaskRemoveWatchPacket,
 * FALSE otherwise
 */
#define GTASK_IS_REMOVE_WATCH_PACKET(obj)  (G_TYPE_CHECK_INSTANCE_TYPE( (obj), \
                                            GTASK_REMOVE_WATCH_PACKET_TYPE ))

/**
 * returns TRUE if the passed in object is a GTaskRemoveWatchPacketClass,
 * FALSE otherwise
 */
#define GTASK_IS_REMOVE_WATCH_PACKET_CLASS(klass) \
                                           (G_TYPE_CHECK_CLASS_TYPE( (klass), \
                                            GTASK_REMOVE_WATCH_PACKET_TYPE ))

#define GTASK_REMOVE_WATCH_PACKET_GET_CLASS(obj) \
                                           (G_TYPE_INSTANCE_GET_CLASS( (obj), \
                                            GTASK_REMOVE_WATCH_PACKET_TYPE, \
                                            GTaskRemoveWatchPacketClass ))

struct _GTaskRemoveWatchPacket {
    GTaskPacket                    parent;
    GTaskRemoveWatchPacketPrivate *private;
};

struct _GTaskRemoveWatchPacketPrivate {
    GString *watch_id;
};

struct _GTaskRemoveWatchPacketClass {
    GTaskPacketClass parent;
};

GType gtask_remove_watch_packet_get_type( void );

GTaskRemoveWatchPacket *
gtask_remove_watch_packet_new( void );

GTaskRemoveWatchPacket *
gtask_remove_watch_packet_new_with_watch_id( const char *watch_id );

const char *
gtask_remove_watch_packet_get_watch_id( GTaskRemoveWatchPacket *packet );

void 
gtask_remove_watch_packet_set_watch_id( GTaskRemoveWatchPacket *packet,
                                        const char *watch_id );

/* @} */

#endif
