/* gTask
 * Copyright (C) 2004 Michael Henson                                       
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef GTASK_TASK_PACKET_H
#define GTASK_TASK_PACKET_H

#include <gtask/gtask-packet.h>
#include <gtask/gtask-generic-task.h>

/** @addtogroup GTaskTaskPacket */

/* @{ */

typedef struct _GTaskTaskPacket        GTaskTaskPacket;
typedef struct _GTaskTaskPacketPrivate GTaskTaskPacketPrivate;
typedef struct _GTaskTaskPacketClass   GTaskTaskPacketClass;


/** returns the GType of GTaskTaskPacket */
#define GTASK_TASK_PACKET_TYPE            (gtask_task_packet_get_type())

/** casts the passed in object to a GTaskTaskPacket */
#define GTASK_TASK_PACKET(obj)            (G_TYPE_CHECK_INSTANCE_CAST( (obj), \
                                           GTASK_TASK_PACKET_TYPE, \
                                           GTaskTaskPacket ))

/** casts the passed in object to a GTaskTaskPacketClass */
#define GTASK_TASK_PACKET_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST( (klass), \
                                           GTASK_TASK_PACKET_TYPE, \
                                           GTaskTaskPacketClass ))

/**
 * returns TRUE if the passed in object is a GTaskTaskPacket,
 * FALSE otherwise
 */
#define GTASK_IS_TASK_PACKET(obj)         (G_TYPE_CHECK_INSTANCE_TYPE( (obj), \
                                           GTASK_TASK_PACKET_TYPE ))

/**
 * returns TRUE if the passed in object is a GTaskTaskPacketClass,
 * FALSE otherwise
 */
#define GTASK_IS_TASK_PACKET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE( (klass), \
                                           GTASK_TASK_PACKET_TYPE ))

#define GTASK_TASK_PACKET_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS( (obj), \
                                           GTASK_TASK_PACKET_TYPE, \
                                           GTaskTaskPacketClass ))

struct _GTaskTaskPacket {
    GTaskPacket             parent;
    GTaskTaskPacketPrivate *private;
};

struct _GTaskTaskPacketPrivate {
    GTaskGenericTask    *task;
    gboolean             dispose_has_run;
};

struct _GTaskTaskPacketClass {
    GTaskPacketClass parent;
};

GType gtask_task_packet_get_type( void );

GTaskTaskPacket *
gtask_task_packet_new_with_task( GTaskGenericTask *task );

GTaskGenericTask *
gtask_task_packet_get_task( GTaskTaskPacket *packet );

/* @} */

#endif
