/* gTask
 * Copyright (C) 2004 Michael Henson                                       
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <gtask/gtask.h>

/* information to set up
 * If the program is a provider
 *      program display name (get from env)
 *      program name         (get from env)
 *
 *      whether or not they are showing their own progress information
 *      scalable icons
 *      a callback for getting umm . . callbacks
 */
void
gtask_init( int *argc, char ***argv, GTaskRole role ) {
    GTaskConnectionGroup *conn_group;
//    GTaskConnection      *conn;

    g_type_init( );

    gtask_factory_set_program( NULL, g_get_prgname() );
    gtask_factory_set_application( NULL, g_get_application_name( ) );

    conn_group = gtask_connection_group_new( );

    /*
    conn = gtask_connection_new_with_properties( "gtaskd", role );

    if( !gtask_connection_connect_domain_socket_default( conn ) ) {
        char *argv[2];

        argv[0] = "gtaskd";
        argv[1] = NULL;

        g_warning( "could not connect to gtaskd, attempting to start it" );

        ** @todo check error *
        if( g_spawn_async( NULL, argv, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, NULL, NULL ) )
        {
            ** @todo should probably wait a second or so before attempting
             *        to connect, or perhaps just queue up the connect
             *        in the evenr loop?
             *
             gtask_connection_connect_domain_socket_default( conn );
        } else {
            g_warning( "error starting up gtaskd" );
        } 
    }

    gtask_connection_group_add_connection( conn_group, conn );
    */

    gtask_factory_set_connection_group( NULL, conn_group );

    //g_object_unref( (GObject *) conn );
    g_object_unref( (GObject *) conn_group );

    printf( "done with setup\n" );
}
